#!/bin/sh
################### LCD-EPG Plugin ##########################################
# Flexmenue: ACTION=LCD-EPG Plugin  ein-/ausschalten,/var/plugins/lcd_epg.sh
#    Config: siehe readme.txt bzw. /var/tuxbox/config/lcd_epg.conf
############################################## - by rich - ##################
VERSION=0.7a
if [ -e /tmp/.lcd_epg.on ]; then
	touch /tmp/.lcd_epg.stop
	rm /tmp/.lcd_epg.on
	while pidof getrc > /dev/null; do
		killall getrc
		i1=`expr ${i1:-0} + 1`
		[ $i1 = 8 ] && break
		sleep 1
	done
	sleep 2 && rm /tmp/.lcd_epg.stop &
	exit 0
else
	if [ -e /tmp/.lcd_epg.stop ]; then
		echo "LCD-EPG error"; exit 1
	fi
	touch /tmp/.lcd_epg.on
fi
load_config() {
	if [ ! -s /var/tuxbox/config/lcd_epg.conf ]; then
		echo "LCD_ANSICHT=1~>RADIO_EPG_ON=0~>SLEEP_INPUT=ON~>SLEEP_STANDBY=ON~>SLEEP_REC=ON~>SLEEP_MAIL=0~>SLEEP_TIMEOUT=7~>INPUT_TIMEOUT=3000~>GETRC=/var/bin/getrc~>~>### Experten-Config ###~>RADIO_TXT_DEL_1=\"^Interpret: *\"~>RADIO_TXT_DEL_2=\"\"~>CHANNEL_FONT=1~>CHANNEL_SIZE=14~>EPG_FONT=0~>EPG_SIZE=11~>EPG_ZEICHEN=19~>UHR_FONT=1~>UHR_SIZE=13~>UHR_POS=84~>BLAU_FONT=2~>BLAU_SIZE=12" | sed -e 's/~>/\n/g' > /var/tuxbox/config/lcd_epg.conf
	fi
	. /var/tuxbox/config/lcd_epg.conf
	if [ $LCD_ANSICHT = 1 ]; then
		ZEILE1=14; ZEILE2=27; ZEILE3=39; ZEILE4=51
	else
		if [ $LCD_ANSICHT = 2 ]; then
			ZEILE1=26; ZEILE2=39; ZEILE3=51
		else
			ZEILE1=25; ZEILE2=38; ZEILE3=50
		fi
	fi
	FONT_INFO=`expr $EPG_SIZE - 1`
	UHR_POS3=`expr "$UHR_POS" - 2`
	BAL_POS1=`expr $UHR_POS - 5`
	BAL_100=`expr $UHR_POS - 18`
	VOL_MAX=$(V1=`expr $UHR_POS - 21`; [ $V1 -gt 60 ] && echo 60 || echo $V1)
	VOL3=`expr $VOL_MAX + 14`
	EPG_INFO=${RADIO_EPG_ON:-0}
	[ $EPG_INFO != 0 -a $EPG_INFO != 1 ] && EPG_RADIO=on || EPG_RADIO=off
	RADIO_DEL_1=`echo "$RADIO_TXT_DEL_1" | sed -e 's/[^ !#-.0-_a-~]/./g'`
	RADIO_DEL_2=`echo "$RADIO_TXT_DEL_2" | sed -e 's/[^ !#-.0-_a-~]/./g'`
	if [ ! -e $GETRC ]; then
		wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&xpos=6&ypos=30&size='$FONT_INFO'&font='$EPG_FONT'&text=Fehler:%20getrc%20wurde%0A%20%20%20nicht%20gefunden!&update=1' > /dev/null
		sleep 10
	fi
}
box_mode() {
	MODE=`wget -q -Y off -O- 'http://localhost/control/getmode' | sed -e 's/[^a-z]//g'`
	SCART_MODE=`wget -q -Y off -O- 'http://localhost/control/scartmode?status' | sed -e 's/[^a-z]//g'`
	if [ "$SLEEP_REC" = ON ]; then
		REC_MODE=`wget -q -Y off -O - 'http://localhost/control/setmode?status' | sed -e 's/[^a-z]//g'`
	else
		REC_MODE=off
	fi
	if [ "$SLEEP_STANDBY" = ON ]; then
		STANDBY=$(M2=`switch -s | sed -n 's/FNC: *//p'`; [ $M2 = 0 ] && echo on || echo off)
	else
		STANDBY=off
	fi
	if [ "$SCART_MODE" != on -a "$STANDBY" != on  -a "$REC_MODE" != on ] && [ "$MODE" = tv -o "$MODE" = radio ]; then
		LCD_MODE=on
	else
		LCD_MODE=off
	fi
}
mail_check() {
	if [ "$SLEEP_MAIL" != 0 -a -e /tmp/tuxmail.new ]; then
		MAIL_TIME=`date +%H:%M`
		MAIL_X=`cat /tmp/tuxmail.new`
		while [ "$MAIL_STOP" != on -a "$MAIL_OFF" != "$MAIL_X" -a -e /tmp/tuxmail.new ]; do
			wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&rect=0,0,119,53,1,0&xpos=27&ypos=14&size='$CHANNEL_SIZE'&font='$CHANNEL_FONT'&text=TUXMAIL' > /dev/null
			wget -q -Y off -O - 'http://localhost/control/lcd?line=0,42,120,42,1&rect=101,2,117,14,1,1&xpos=3&ypos=27&size='$FONT_INFO'&font='$EPG_FONT'&text=%20%20Neue%20E-Mails%20sind%0A%20%20%20%20%20%20eingetroffen!%0A'`echo "$MAIL_X" | sed -e '1{s/^.$/%20%20&/;s/^..$/%20&/}'`'%20E-Mail%20'${MAIL_TIME:---:--}'Uhr' > /dev/null
			wget -q -Y off -O - 'http://localhost/control/lcd?line=0,16,120,16,1&rect=2,2,18,14,1,10&xpos=48&ypos=63&size=''$BLAU_SIZE''&font='$BLAU_FONT'&text=ausblenden[BLAU]&update=1' > /dev/null
			TIMEOUT=`$GETRC timeout=20000`
			[ -s $TIMEOUT ] && break 2
			[ "$TIMEOUT" = K ] && MAIL_OFF=$MAIL_X
			if [ "$TIMEOUT" != X ]; then
				[ $SLEEP_INPUT = ON -a -e /tmp/lcd.locked ] && rm /tmp/lcd.locked
				while [ "$TIMEOUT" != X ]; do
					TIMEOUT=`$GETRC timeout=$INPUT_TIMEOUT`
					[ -s $TIMEOUT ] && break 3
				done
			fi
			if [ -e /tmp/tuxmail.new ]; then
				MAIL_X2=`cat /tmp/tuxmail.new`
				if [ "$MAIL_X" != "$MAIL_X2" ]; then
					MAIL_TIME=`date +%H:%M`
				fi
				MAIL_X="$MAIL_X2"
			else
				MAIL_OFF=OFF
			fi
			if [ "$SLEEP_MAIL" = 1 ]; then
				box_mode
				[ $LCD_MODE = off ] && MAIL_STOP=on
			fi
		done
	else
		[ "$SLEEP_MAIL" != 0 ] && MAIL_OFF=OFF
	fi
}
ch_list() {
	CH_LIST=`wget -q -Y off -O - http://localhost/control/channellist | sed -e '{s/'\%'/%25/g;s/'\'/%C3%84/g;s/'\'/%C3%96/g;s/'\'/%C3%9C/g;s/'\'/%C3%A4/g;s/'\'/%C3%B6/g;s/'\'/%C3%BC/g;s/'\'/%C3%9F/g;s/'\'/%C3%AB/g;s/'\'/%C3%A9/g;s/'\'/%C3%A0/g;s/'\+'/%2B/g;s/'\&'/ u./g;s/'\'//g;s/[^ -~]/_/g}'`
}
ch_name() {
	CH_NAME=`echo "$CH_LIST" | sed -n 's/^'$CHANNEL_ID' //p' | sed -n '1p' | sed -e 's/ /%20/g'`
}
load_config
ch_list
while [ -e /tmp/.lcd_epg.on ]; do
	if [ -e /tmp/.lcd_epg.reload ]; then
		rm /tmp/.lcd_epg.reload
		load_config
	fi
	CHANNEL_ID=`wget -q -Y off -O - http://localhost/control/zapto`
	MODE=`wget -q -Y off -O- 'http://localhost/control/getmode' | sed -e 's/[^a-z]//g'`
	if [ "$MODE" = tv -o "$EPG_RADIO" != on ]; then
		ch_name
		if [ "$CH_NAME" = "" ]; then
			ch_list
			ch_name
		fi
	fi
	JETZT=`wget -q -Y off -O - http://localhost/control/epg?ext | sed -n '/^'$CHANNEL_ID' /p' | sed -n 1p`
	LANG=`echo "$JETZT" | cut -d" " -f3`
	if [ ! -s $LANG ]; then
		if [ "$MODE" = radio -a "$EPG_RADIO" = on ]; then
			[ "$EPG_INFO" != 1 ] && CH_NAME=`echo "$JETZT" | cut -d" " -f5- | sed -e 's/'"${RADIO_DEL_1:-^}"'//g' | sed -e '{s/'\%'/%25/g;s/'\'/%C3%84/g;s/'\'/%C3%96/g;s/'\'/%C3%9C/g;s/'\'/%C3%A4/g;s/'\'/%C3%B6/g;s/'\'/%C3%BC/g;s/'\'/%C3%9F/g;s/'\'/%C3%AB/g;s/'\'/%C3%A9/g;s/'\'/%C3%A0/g;s/'\+'/%2B/g;s/'\&'/ u./g;s/'\'//g;s/[^ -~]/_/g;s/ /%20/g}'`
			SENDUNG=`wget -q -Y off -O - http://localhost/control/epg?eventid=$(echo "$JETZT" | cut -d" " -f4) | sed -n $EPG_INFO'p' | sed -e 's/'"${RADIO_DEL_2:-^}"'//g' | sed -e '{s/$/ /;s/.\{,'$EPG_ZEICHEN'\}[ -]/&\n/}' | sed -e '2{s/$/ /;s/.\{,'$EPG_ZEICHEN'\}[ -]/&\n/}' | sed -e '{s/'\%'/%25/g;s/'\'/%C3%84/g;s/'\'/%C3%96/g;s/'\'/%C3%9C/g;s/'\'/%C3%A4/g;s/'\'/%C3%B6/g;s/'\'/%C3%BC/g;s/'\'/%C3%9F/g;s/'\'/%C3%AB/g;s/'\'/%C3%A9/g;s/'\'/%C3%A0/g;s/'\+'/%2B/g;s/'\&'/ u./g;s/'\'//g;s/[^ -~]/_/g;s/_ *$//;s/ /%20/g}'`
		else
			SENDUNG=`echo "$JETZT" | cut -d" " -f5- | sed -e '{s/$/ /;s/.\{,'$EPG_ZEICHEN'\}[ -]/&\n/}' | sed -e '2{s/$/ /;s/.\{,'$EPG_ZEICHEN'\}[ -]/&\n/}' | sed -e '{s/'\%'/%25/g;s/'\'/%C3%84/g;s/'\'/%C3%96/g;s/'\'/%C3%9C/g;s/'\'/%C3%A4/g;s/'\'/%C3%B6/g;s/'\'/%C3%BC/g;s/'\'/%C3%9F/g;s/'\'/%C3%AB/g;s/'\'/%C3%A9/g;s/'\'/%C3%A0/g;s/'\+'/%2B/g;s/'\&'/ u./g;s/'\'//g;s/[^ -~]/_/g;s/ /%20/g}'`
		fi
		SEC_VORBEI=$(expr `date +%s` - `echo "$JETZT" | cut -d" " -f2`)
		REST_TITEL=`expr $LANG - $SEC_VORBEI | sed -e 's/^-.*/2/'`
		VORBEI=`expr $SEC_VORBEI'00' \/ $LANG`
		EPG_OK=rect
	else
		SENDUNG="-%20keine%20EPG-Info%20-"; EPG_OK=line; VORBEI=100
		if [ "$EPG_RADIO" = on ]; then
			ch_name
			if [ "$CH_NAME" = "" ]; then
				ch_list
				ch_name
			fi
		fi
	fi
	if [ $LCD_ANSICHT = 1 ]; then
		wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&xpos=0&ypos='$ZEILE4'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '3p` > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?xpos=0&ypos='$ZEILE3'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '2p'` > /dev/null
	fi
	if [ $LCD_ANSICHT = 2 ]; then
		wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&png=/share/tuxbox/lcdd/icons/setup.png&xpos=0&ypos='$ZEILE3'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '2p'``echo "$SENDUNG" | sed -n '3p'` > /dev/null
	fi
	ZEIT=`date +%H:%M`
	if [ $LCD_ANSICHT != 3 ]; then
		wget -q -Y off -O - 'http://localhost/control/lcd?raw=0,55,7,8,255,170,255,136,136,136,255,170&rect=9,55,'$BAL_POS1',63,1,0&xpos='$UHR_POS'&ypos=64&size='$UHR_SIZE'&font='$UHR_FONT'&text='${ZEIT:-%20--:--} > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?raw=0,63,7,1,255&'$EPG_OK'=11,57,'`expr $VORBEI \* $BAL_100 \/ 100 + 11`',61,1,1&xpos=0&ypos='$ZEILE2'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '1p'` > /dev/null
	else
		VOLUME=`expr $(wget -q -Y off -O - http://localhost/control/volume) \* $VOL_MAX \/ 100 + 12`
		MUTE=$(M1=`wget -q -Y off -O - http://localhost/control/volume?status`; [ $M1 = 1 ] && echo 0 || echo 1)
		wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&raw=1,1,7,8,255,170,255,136,136,136,255,170&rect=10,1,118,9,1,0&xpos=0&ypos='$ZEILE2'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '1p'` > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?raw=1,9,7,1,255&'$EPG_OK'=12,3,'`expr $VORBEI \* 104 \/ 100 + 12`',7,1,1&xpos=0&ypos='$ZEILE3'&size='$EPG_SIZE'&font='$EPG_FONT'&text='`echo "$SENDUNG" | sed -n '2p'``echo "$SENDUNG" | sed -n '3p'` > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?rect=10,53,'$VOL3',61,1,0' > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?raw=1,52,6,8,4,8,20,228,164,164,228,20&rect=12,55,'$VOLUME',59,1,'$MUTE > /dev/null
		wget -q -Y off -O - 'http://localhost/control/lcd?raw=1,60,6,2,8,4&line=12,57,'$VOLUME',57,'$MUTE',0&xpos='$UHR_POS3'&ypos=62&size='$UHR_SIZE'&font='$UHR_FONT'&text='${ZEIT:-%20--:--} > /dev/null
	fi
	REST_SEC=`expr 60 - $(date +%S | sed -e 's/^0//')`
	if [ "$EPG_OK" = rect ]; then
		if [ $REST_SEC -lt $REST_TITEL ]; then
			LCD_OUT=$REST_SEC
		else
			LCD_OUT=$REST_TITEL
		fi
		if [ $LANG -le 2640 ]; then
			[ $LCD_OUT -ge 25 ] && LCD_OUT=15
		fi
	else
		[ $REST_SEC -ge 20 ] && LCD_OUT=15 || LCD_OUT=$REST_SEC
	fi
	if [ -e /tmp/.lcd_epg.on ]; then
		box_mode
		if [ $LCD_MODE = on ]; then
			if [ $CHANNEL_ID = `wget -q -Y off -O - http://localhost/control/zapto` ]; then
				wget -q -Y off -O - 'http://localhost/control/lcd?xpos=0&ypos='$ZEILE1'&size='$CHANNEL_SIZE'&font='$CHANNEL_FONT'&text='${CH_NAME:-<<%20?%20>>}'&update=1' > /dev/null
				TIMEOUT=`$GETRC timeout=$(expr $LCD_OUT + 1)000`
				if [ "$TIMEOUT" = I ]; then
					if [ "$MODE" = radio -a "$EPG_OK" = rect ]; then
						while [ "$TIMEOUT" = I ]; do
							wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&xpos=0&ypos=25&size='$EPG_SIZE'&font='$EPG_FONT'&text=Bitte%20ausw%C3%A4hlen%20...%0AEPG-Zeile:%20'`echo $EPG_INFO | sed -e 's/^0/aus/'`'&update=1' > /dev/null
							TIMEOUT=`$GETRC timeout=$INPUT_TIMEOUT`
							[ -s $TIMEOUT ] && break 2
							[ "$TIMEOUT" = I ] && EPG_INFO=`expr $EPG_INFO + 1`
							[ "$EPG_INFO" = 11 ] && EPG_INFO=0
						done
						wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&xpos=0&ypos=25&size='$EPG_SIZE'&font='$EPG_FONT'&text=EPG-Zeile:%20'`echo $EPG_INFO | sed -e 's/^0/aus/'`'%0ABitte warten ...&update=1' > /dev/null
						if [ "$EPG_INFO" = 0 -o "$EPG_INFO" = 1 ]; then
							EPG_RADIO=off
						else
							EPG_RADIO=on
						fi
					fi
				fi
				if [ "$TIMEOUT" != X ]; then
					[ $SLEEP_INPUT = ON -a -e /tmp/lcd.locked ] && rm /tmp/lcd.locked
					while [ "$TIMEOUT" != X ]; do
						TIMEOUT=`$GETRC timeout=$INPUT_TIMEOUT`
						[ -s $TIMEOUT ] && break 2
					done
				fi
				mail_check
			fi
		else
			[ -e /tmp/lcd.locked ] && rm /tmp/lcd.locked
			while [ $LCD_MODE = off ]; do
				[ ! -e /tmp/.lcd_epg.on ] && break 2
				echo "LCD-EPG sleep"
				TIMEOUT=`$GETRC timeout=${SLEEP_TIMEOUT}000`
				[ -s $TIMEOUT ] && break 2
				[ "$SLEEP_MAIL" = 2 ] && mail_check
				box_mode
			done
			MAIL_STOP=off
		fi
	fi
done
wget -q -Y off -O - 'http://localhost/control/lcd?lock=1&clear=1&png=/share/tuxbox/lcdd/icons/setup.png&xpos=6&ypos=30&size='$FONT_INFO'&font='$EPG_FONT'&text=LCD-EPG%20%20V'$VERSION'%0Awird%20beendet%20...' > /dev/null
wget -q -Y off -O - 'http://localhost/control/lcd?xpos=63&ypos=60&size='$FONT_INFO'&font='$EPG_FONT'&text=-%20by%20rich%20-&update=1' > /dev/null
sleep 3
wget -q -Y off -O - 'http://localhost/control/lcd?lock=0' > /dev/null
[ -e /tmp/.lcd_epg.on ] && rm /tmp/.lcd_epg.on
echo "LCD-EPG beendet"
exit 0
